Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7712)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7713)
@@ -21,4 +21,5 @@
    USE par_oce
    USE dom_oce                  ! Ocean space and time domain variables
+   USE obs_const, ONLY: obfillflt ! Fill value
    USE obs_fbm, ONLY: ln_cl4    ! Class 4 diagnostic switch
    USE obs_read_prof            ! Reading and allocation of observations (Coriolis)
@@ -29,4 +30,8 @@
    USE obs_read_seaice          ! Reading and allocation of Sea Ice observations  
    USE obs_read_vel             ! Reading and allocation of velocity component observations
+   USE obs_read_logchl          ! Reading and allocation of logchl observations
+   USE obs_read_spm             ! Reading and allocation of spm observations
+   USE obs_read_fco2            ! Reading and allocation of fco2 observations
+   USE obs_read_pco2            ! Reading and allocation of pco2 observations
    USE obs_prep                 ! Preparation of obs. (grid search etc).
    USE obs_oper                 ! Observation operators
@@ -40,4 +45,8 @@
    USE obs_sst                  ! SST data storage
    USE obs_seaice               ! Sea Ice data storage
+   USE obs_logchl               ! logchl data storage
+   USE obs_spm                  ! spm data storage
+   USE obs_fco2                 ! fco2 data storage
+   USE obs_pco2                 ! pco2 data storage
    USE obs_types                ! Definitions for observation types
    USE mpp_map                  ! MPP mapping
@@ -81,4 +90,12 @@
    LOGICAL, PUBLIC :: ln_velhradcp   !: Logical switch for raw high freq netCDF ADCP vel. data 
    LOGICAL, PUBLIC :: ln_velfb       !: Logical switch for velocities from feedback files
+   LOGICAL, PUBLIC :: ln_logchl      !: Logical switch for log10(chlorophyll)
+   LOGICAL, PUBLIC :: ln_logchlfb    !: Logical switch for logchl from feedback files
+   LOGICAL, PUBLIC :: ln_spm         !: Logical switch for spm
+   LOGICAL, PUBLIC :: ln_spmfb       !: Logical switch for spm from feedback files
+   LOGICAL, PUBLIC :: ln_fco2        !: Logical switch for fco2
+   LOGICAL, PUBLIC :: ln_fco2fb      !: Logical switch for fco2 from feedback files
+   LOGICAL, PUBLIC :: ln_pco2        !: Logical switch for pco2
+   LOGICAL, PUBLIC :: ln_pco2fb      !: Logical switch for pco2 from feedback files
    LOGICAL, PUBLIC :: ln_ssh         !: Logical switch for sea surface height
    LOGICAL, PUBLIC :: ln_sss         !: Logical switch for sea surface salinity
@@ -164,4 +181,12 @@
       CHARACTER(len=128) :: velhradcpfiles(MaxNumFiles)
       CHARACTER(len=128) :: velfbfiles(MaxNumFiles)
+      CHARACTER(len=128) :: logchlfiles(MaxNumFiles)
+      CHARACTER(len=128) :: logchlfbfiles(MaxNumFiles)
+      CHARACTER(len=128) :: spmfiles(MaxNumFiles)
+      CHARACTER(len=128) :: spmfbfiles(MaxNumFiles)
+      CHARACTER(len=128) :: fco2files(MaxNumFiles)
+      CHARACTER(len=128) :: fco2fbfiles(MaxNumFiles)
+      CHARACTER(len=128) :: pco2files(MaxNumFiles)
+      CHARACTER(len=128) :: pco2fbfiles(MaxNumFiles)
       CHARACTER(LEN=128) :: reysstname
       CHARACTER(LEN=12)  :: reysstfmt
@@ -189,4 +214,12 @@
          &            ln_velhradcp, velhradcpfiles,                   &
          &            ln_velfb, velfbfiles, ln_velfb_av,              &
+         &            ln_logchl, ln_logchlfb,                         &
+         &            logchlfiles, logchlfbfiles,                     &
+         &            ln_spm, ln_spmfb,                               &
+         &            spmfiles, spmfbfiles,                           &
+         &            ln_fco2, ln_fco2fb,                             &
+         &            fco2files, fco2fbfiles,                         &
+         &            ln_pco2, ln_pco2fb,                             &
+         &            pco2files, pco2fbfiles,                         &
          &            ln_profb_enatim, ln_ignmis, ln_cl4,             &
          &            ln_sstbias, sstbias_files
@@ -210,4 +243,12 @@
       INTEGER :: jnumvelhradcp   
       INTEGER :: jnumvelfb
+      INTEGER :: jnumlogchl
+      INTEGER :: jnumlogchlfb
+      INTEGER :: jnumspm
+      INTEGER :: jnumspmfb
+      INTEGER :: jnumfco2
+      INTEGER :: jnumfco2fb
+      INTEGER :: jnumpco2
+      INTEGER :: jnumpco2fb
       INTEGER :: ji
       INTEGER :: jset
@@ -218,4 +259,13 @@
       ! Read namelist parameters
       !-----------------------------------------------------------------------
+
+      ln_logchl   = .FALSE.
+      ln_logchlfb = .FALSE.
+      ln_spm      = .FALSE.
+      ln_spmfb    = .FALSE.
+      ln_fco2     = .FALSE.
+      ln_fco2fb   = .FALSE.
+      ln_pco2     = .FALSE.
+      ln_pco2fb   = .FALSE.
       
       !Initalise all values in namelist arrays
@@ -238,4 +288,12 @@
       velcurfiles(:) = ''
       veladcpfiles(:) = ''
+      logchlfiles(:) = ''
+      logchlfbfiles(:) = ''
+      spmfiles(:) = ''
+      spmfbfiles(:) = ''
+      fco2files(:) = ''
+      fco2fbfiles(:) = ''
+      pco2files(:) = ''
+      pco2fbfiles(:) = ''
       sstbias_files(:) = ''
       endailyavtypes(:) = -1
@@ -337,4 +395,44 @@
          jnumvelfb = COUNT(lmask)
          lmask(:) = .FALSE.
+      ENDIF
+      IF (ln_logchl) THEN
+         lmask(:) = .FALSE.
+         WHERE (logchlfiles(:) /= '') lmask(:) = .TRUE.
+         jnumlogchl = COUNT(lmask)
+      ENDIF
+      IF (ln_logchlfb) THEN
+         lmask(:) = .FALSE.
+         WHERE (logchlfbfiles(:) /= '') lmask(:) = .TRUE.
+         jnumlogchlfb = COUNT(lmask)
+      ENDIF
+      IF (ln_spm) THEN
+         lmask(:) = .FALSE.
+         WHERE (spmfiles(:) /= '') lmask(:) = .TRUE.
+         jnumspm = COUNT(lmask)
+      ENDIF
+      IF (ln_spmfb) THEN
+         lmask(:) = .FALSE.
+         WHERE (spmfbfiles(:) /= '') lmask(:) = .TRUE.
+         jnumspmfb = COUNT(lmask)
+      ENDIF
+      IF (ln_fco2) THEN
+         lmask(:) = .FALSE.
+         WHERE (fco2files(:) /= '') lmask(:) = .TRUE.
+         jnumfco2 = COUNT(lmask)
+      ENDIF
+      IF (ln_fco2fb) THEN
+         lmask(:) = .FALSE.
+         WHERE (fco2fbfiles(:) /= '') lmask(:) = .TRUE.
+         jnumfco2fb = COUNT(lmask)
+      ENDIF
+      IF (ln_pco2) THEN
+         lmask(:) = .FALSE.
+         WHERE (pco2files(:) /= '') lmask(:) = .TRUE.
+         jnumpco2 = COUNT(lmask)
+      ENDIF
+      IF (ln_pco2fb) THEN
+         lmask(:) = .FALSE.
+         WHERE (pco2fbfiles(:) /= '') lmask(:) = .TRUE.
+         jnumpco2fb = COUNT(lmask)
       ENDIF
       
@@ -368,4 +466,12 @@
          WRITE(numout,*) '             Logical switch for velocity high freq. ADCP  ln_velhradcp = ', ln_velhradcp
          WRITE(numout,*) '             Logical switch for feedback velocity data        ln_velfb = ', ln_velfb
+         WRITE(numout,*) '             Logical switch for logchl observations          ln_logchl = ', ln_logchl
+         WRITE(numout,*) '             Logical switch for feedback logchl data       ln_logchlfb = ', ln_logchlfb
+         WRITE(numout,*) '             Logical switch for spm observations                ln_spm = ', ln_spm
+         WRITE(numout,*) '             Logical switch for feedback spm data             ln_spmfb = ', ln_spmfb
+         WRITE(numout,*) '             Logical switch for fco2 observations              ln_fco2 = ', ln_fco2
+         WRITE(numout,*) '             Logical switch for pco2 observations              ln_pco2 = ', ln_pco2
+         WRITE(numout,*) '             Logical switch for feedback pco2 data           ln_pco2fb = ', ln_pco2fb
+         WRITE(numout,*) '             Logical switch for feedback fco2 data           ln_fco2fb = ', ln_fco2fb
          WRITE(numout,*) '             Global distribtion of observations         ln_grid_global = ',ln_grid_global
          WRITE(numout,*) &
@@ -464,4 +570,52 @@
                      TRIM(velfbfiles(ji))
                ENDIF
+            END DO
+         ENDIF
+         IF (ln_logchl) THEN
+            DO ji = 1, jnumlogchl
+               WRITE(numout,'(1X,2A)') '             logchl input observation file name        logchlfiles = ', &
+                  TRIM(logchlfiles(ji))
+            END DO
+         ENDIF
+         IF (ln_logchlfb) THEN
+            DO ji = 1, jnumlogchlfb
+               WRITE(numout,'(1X,2A)') '        Feedback logchl input observation file name  logchlfbfiles = ', &
+                  TRIM(logchlfbfiles(ji))
+            END DO
+         ENDIF
+         IF (ln_spm) THEN
+            DO ji = 1, jnumspm
+               WRITE(numout,'(1X,2A)') '             spm input observation file name              spmfiles = ', &
+                  TRIM(spmfiles(ji))
+            END DO
+         ENDIF
+         IF (ln_spmfb) THEN
+            DO ji = 1, jnumspmfb
+               WRITE(numout,'(1X,2A)') '             Feedback spm input observation file name   spmfbfiles = ', &
+                  TRIM(spmfbfiles(ji))
+            END DO
+         ENDIF
+         IF (ln_fco2) THEN
+            DO ji = 1, jnumfco2
+               WRITE(numout,'(1X,2A)') '             fco2 input observation file name            fco2files = ', &
+                  TRIM(fco2files(ji))
+            END DO
+         ENDIF
+         IF (ln_fco2fb) THEN
+            DO ji = 1, jnumfco2fb
+               WRITE(numout,'(1X,2A)') '            Feedback fco2 input observation file name  fco2fbfiles = ', &
+                  TRIM(fco2fbfiles(ji))
+            END DO
+         ENDIF
+         IF (ln_pco2) THEN
+            DO ji = 1, jnumpco2
+               WRITE(numout,'(1X,2A)') '             pco2 input observation file name            pco2files = ', &
+                  TRIM(pco2files(ji))
+            END DO
+         ENDIF
+         IF (ln_pco2fb) THEN
+            DO ji = 1, jnumpco2fb
+               WRITE(numout,'(1X,2A)') '            Feedback pco2 input observation file name  pco2fbfiles = ', &
+                  TRIM(pco2fbfiles(ji))
             END DO
          ENDIF
@@ -501,8 +655,10 @@
          & ( .NOT. ln_vel3d ).AND.                                         &
          & ( .NOT. ln_ssh ).AND.( .NOT. ln_sst ).AND.( .NOT. ln_sss ).AND. &
-         & ( .NOT. ln_seaice ).AND.( .NOT. ln_vel3d ) ) THEN
+         & ( .NOT. ln_seaice ).AND.( .NOT. ln_vel3d ).AND.( .NOT. ln_logchl ).AND. &
+         & ( .NOT. ln_spm ).AND.( .NOT. ln_fco2 ).AND.( .NOT. ln_pco2 ) ) THEN
          IF(lwp) WRITE(numout,cform_war)
          IF(lwp) WRITE(numout,*) ' key_diaobs is activated but logical flags', &
-            &                    ' ln_t3d, ln_s3d, ln_sla, ln_ssh, ln_sst, ln_sss, ln_seaice, ln_vel3d are all set to .FALSE.'
+            &                    ' ln_t3d, ln_s3d, ln_sla, ln_ssh, ln_sst, ln_sss, ln_seaice, ln_vel3d,', &
+            &                    ' ln_logchl, ln_spm, ln_fco2, ln_pco2 are all set to .FALSE.'
          nwarn = nwarn + 1
       ENDIF
@@ -1002,4 +1158,224 @@
 
       ENDIF
+
+      !  - log10(chlorophyll)
+      
+      IF ( ln_logchl ) THEN
+
+         ! Set the number of variables for logchl to 1
+         nlogchlvars = 1
+
+         ! Set the number of extra variables for logchl to 0
+         nlogchlextr = 0
+         
+         IF ( ln_logchlfb ) THEN
+            nlogchlsets = jnumlogchlfb
+         ELSE
+            nlogchlsets = 1
+         ENDIF
+
+         ALLOCATE(logchldata(nlogchlsets))
+         ALLOCATE(logchldatqc(nlogchlsets))
+         logchldata(:)%nsurf=0
+         logchldatqc(:)%nsurf=0
+
+         nlogchlsets = 0
+
+         IF ( ln_logchlfb ) THEN             ! Feedback file format
+
+            DO jset = 1, jnumlogchlfb
+            
+               nlogchlsets = nlogchlsets + 1
+
+               CALL obs_rea_logchl( 0, logchldata(nlogchlsets), 1, &
+                  &                 logchlfbfiles(jset:jset), &
+                  &                 nlogchlvars, nlogchlextr, nitend-nit000+2, &
+                  &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+               CALL obs_pre_logchl( logchldata(nlogchlsets), logchldatqc(nlogchlsets), &
+                  &                 ln_logchl, ln_nea )
+            
+            ENDDO
+
+         ELSE                              ! Original file format
+
+            nlogchlsets = nlogchlsets + 1
+
+            CALL obs_rea_logchl( 1, logchldata(nlogchlsets), jnumlogchl, &
+               &                 logchlfiles(1:jnumlogchl), &
+               &                 nlogchlvars, nlogchlextr, nitend-nit000+2, &
+               &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+            CALL obs_pre_logchl( logchldata(nlogchlsets), logchldatqc(nlogchlsets), &
+               &                 ln_logchl, ln_nea )
+
+         ENDIF
+ 
+      ENDIF
+
+      !  - spm
+      
+      IF ( ln_spm ) THEN
+
+         ! Set the number of variables for spm to 1
+         nspmvars = 1
+
+         ! Set the number of extra variables for spm to 0
+         nspmextr = 0
+         
+         IF ( ln_spmfb ) THEN
+            nspmsets = jnumspmfb
+         ELSE
+            nspmsets = 1
+         ENDIF
+
+         ALLOCATE(spmdata(nspmsets))
+         ALLOCATE(spmdatqc(nspmsets))
+         spmdata(:)%nsurf=0
+         spmdatqc(:)%nsurf=0
+
+         nspmsets = 0
+
+         IF ( ln_spmfb ) THEN             ! Feedback file format
+
+            DO jset = 1, jnumspmfb
+            
+               nspmsets = nspmsets + 1
+
+               CALL obs_rea_spm( 0, spmdata(nspmsets), 1, &
+                  &                 spmfbfiles(jset:jset), &
+                  &                 nspmvars, nspmextr, nitend-nit000+2, &
+                  &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+               CALL obs_pre_spm( spmdata(nspmsets), spmdatqc(nspmsets), &
+                  &                 ln_spm, ln_nea )
+            
+            ENDDO
+
+         ELSE                              ! Original file format
+
+            nspmsets = nspmsets + 1
+
+            CALL obs_rea_spm( 1, spmdata(nspmsets), jnumspm, &
+               &                 spmfiles(1:jnumspm), &
+               &                 nspmvars, nspmextr, nitend-nit000+2, &
+               &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+            CALL obs_pre_spm( spmdata(nspmsets), spmdatqc(nspmsets), &
+               &                 ln_spm, ln_nea )
+
+         ENDIF
+ 
+      ENDIF
+
+      !  - fco2
+      
+      IF ( ln_fco2 ) THEN
+
+         ! Set the number of variables for fco2 to 1
+         nfco2vars = 1
+
+         ! Set the number of extra variables for fco2 to 0
+         nfco2extr = 0
+         
+         IF ( ln_fco2fb ) THEN
+            nfco2sets = jnumfco2fb
+         ELSE
+            nfco2sets = 1
+         ENDIF
+
+         ALLOCATE(fco2data(nfco2sets))
+         ALLOCATE(fco2datqc(nfco2sets))
+         fco2data(:)%nsurf=0
+         fco2datqc(:)%nsurf=0
+
+         nfco2sets = 0
+
+         IF ( ln_fco2fb ) THEN             ! Feedback file format
+
+            DO jset = 1, jnumfco2fb
+            
+               nfco2sets = nfco2sets + 1
+
+               CALL obs_rea_fco2( 0, fco2data(nfco2sets), 1, &
+                  &                 fco2fbfiles(jset:jset), &
+                  &                 nfco2vars, nfco2extr, nitend-nit000+2, &
+                  &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+               CALL obs_pre_fco2( fco2data(nfco2sets), fco2datqc(nfco2sets), &
+                  &                 ln_fco2, ln_nea )
+            
+            ENDDO
+
+         ELSE                              ! Original file format
+
+            nfco2sets = nfco2sets + 1
+
+            CALL obs_rea_fco2( 1, fco2data(nfco2sets), jnumfco2, &
+               &                 fco2files(1:jnumfco2), &
+               &                 nfco2vars, nfco2extr, nitend-nit000+2, &
+               &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+            CALL obs_pre_fco2( fco2data(nfco2sets), fco2datqc(nfco2sets), &
+               &                 ln_fco2, ln_nea )
+
+         ENDIF
+ 
+      ENDIF
+
+      !  - pco2
+      
+      IF ( ln_pco2 ) THEN
+
+         ! Set the number of variables for pco2 to 1
+         npco2vars = 1
+
+         ! Set the number of extra variables for pco2 to 0
+         npco2extr = 0
+         
+         IF ( ln_pco2fb ) THEN
+            npco2sets = jnumpco2fb
+         ELSE
+            npco2sets = 1
+         ENDIF
+
+         ALLOCATE(pco2data(npco2sets))
+         ALLOCATE(pco2datqc(npco2sets))
+         pco2data(:)%nsurf=0
+         pco2datqc(:)%nsurf=0
+
+         npco2sets = 0
+
+         IF ( ln_pco2fb ) THEN             ! Feedback file format
+
+            DO jset = 1, jnumpco2fb
+            
+               npco2sets = npco2sets + 1
+
+               CALL obs_rea_pco2( 0, pco2data(npco2sets), 1, &
+                  &                 pco2fbfiles(jset:jset), &
+                  &                 npco2vars, npco2extr, nitend-nit000+2, &
+                  &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+               CALL obs_pre_pco2( pco2data(npco2sets), pco2datqc(npco2sets), &
+                  &                 ln_pco2, ln_nea )
+            
+            ENDDO
+
+         ELSE                              ! Original file format
+
+            npco2sets = npco2sets + 1
+
+            CALL obs_rea_pco2( 1, pco2data(npco2sets), jnumpco2, &
+               &                 pco2files(1:jnumpco2), &
+               &                 npco2vars, npco2extr, nitend-nit000+2, &
+               &                 dobsini, dobsend, ln_ignmis, .FALSE. )
+
+            CALL obs_pre_pco2( pco2data(npco2sets), pco2datqc(npco2sets), &
+               &                 ln_pco2, ln_nea )
+
+         ENDIF
+ 
+      ENDIF
      
    END SUBROUTINE dia_obs_init
@@ -1019,4 +1395,8 @@
       !!               - Sea surface salinity
       !!               - Velocity component (U,V) profiles
+      !!               - Sea surface log10(chlorophyll)
+      !!               - Sea surface spm
+      !!               - Sea surface fco2
+      !!               - Sea surface pco2
       !!
       !! ** Action  : 
@@ -1043,5 +1423,6 @@
          & tmask, umask, vmask                            
       USE phycst, ONLY : &              ! Physical constants
-         & rday                         
+         & rday, &
+         & rt0
       USE oce, ONLY : &                 ! Ocean dynamics and tracers variables
          & tsn,  &             
@@ -1056,4 +1437,26 @@
          & frld
 #endif
+#if defined key_hadocc
+      USE trc, ONLY :  &                ! HadOCC chlorophyll, fCO2 and pCO2
+         & HADOCC_CHL, &
+         & HADOCC_FCO2, &
+         & HADOCC_PCO2, &
+         & HADOCC_FILL_FLT
+#elif defined key_medusa && defined key_foam_medusa
+      USE trc, ONLY :  &                ! MEDUSA chlorophyll, fCO2 and pCO2
+         & MEDUSA_CHL, &
+         & MEDUSA_FCO2, &
+         & MEDUSA_PCO2, &
+         & MEDUSA_FILL_FLT
+#elif defined key_fabm
+      USE fabm
+      USE par_fabm
+#endif
+#if defined key_spm
+      USE par_spm, ONLY: &              ! ERSEM/SPM sediments
+         & jp_spm
+      USE trc, ONLY :  &
+         & trn
+#endif
       IMPLICIT NONE
 
@@ -1067,7 +1470,31 @@
       INTEGER :: jseaiceset             ! sea ice data set loop variable
       INTEGER :: jveloset               ! velocity profile data loop variable
+      INTEGER :: jlogchlset             ! logchl data set loop variable
+      INTEGER :: jspmset                ! spm data set loop variable
+      INTEGER :: jfco2set               ! fco2 data set loop variable
+      INTEGER :: jpco2set               ! pco2 data set loop variable
       INTEGER :: jvar                   ! Variable number    
 #if ! defined key_lim2 && ! defined key_lim3
       REAL(wp), POINTER, DIMENSION(:,:) :: frld   
+#endif
+      REAL(wp) :: tiny                  ! small number
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         logchl                         ! array for log chlorophyll
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         maskchl                        ! array for special chlorophyll mask
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         spm                            ! array for spm
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         fco2                           ! array for fco2
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         maskfco2                       ! array for special fco2 mask
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         pco2                           ! array for pco2
+      REAL(wp), DIMENSION(jpi,jpj) :: &
+         maskpco2                       ! array for special pco2 mask
+      INTEGER :: jn                     ! loop index
+#if defined key_fabm
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: logchl_3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: pco2_3d
 #endif
       CHARACTER(LEN=20) :: datestr=" ",timestr=" "
@@ -1180,4 +1607,144 @@
       ENDIF
 
+      IF ( ln_logchl ) THEN
+
+#if defined key_hadocc
+         logchl(:,:) = HADOCC_CHL(:,:,1)    ! (not log) chlorophyll from HadOCC
+#elif defined key_medusa && defined key_foam_medusa
+         logchl(:,:) = MEDUSA_CHL(:,:,1)    ! (not log) chlorophyll from HadOCC
+#elif defined key_fabm
+         logchl_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabmdia_chltot)
+         logchl(:,:) = logchl_3d(:,:,1)
+#else
+         CALL ctl_stop( ' Trying to run logchl observation operator', &
+            &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+         maskchl(:,:) = tmask(:,:,1)         ! create a special mask to exclude certain things
+
+         ! Take the log10 where we can, otherwise exclude
+         tiny = 1.0e-20
+         WHERE(logchl(:,:) > tiny .AND. logchl(:,:) /= obfillflt )
+            logchl(:,:)  = LOG10(logchl(:,:))
+         ELSEWHERE
+            logchl(:,:)  = obfillflt
+            maskchl(:,:) = 0
+         END WHERE
+
+         DO jlogchlset = 1, nlogchlsets
+             CALL obs_logchl_opt( logchldatqc(jlogchlset),             &
+               &                  kstp, jpi, jpj, nit000, logchl(:,:), &
+               &                  maskchl(:,:), n2dint )
+         END DO         
+      ENDIF 
+
+      IF ( ln_spm ) THEN
+#if defined key_spm
+         spm(:,:) = 0.0
+         DO jn = 1, jp_spm
+            spm(:,:) = spm(:,:) + trn(:,:,1,jn)   ! sum SPM sizes
+         END DO
+#else
+         CALL ctl_stop( ' Trying to run spm observation operator', &
+            &           ' but no spm model appears to have been defined' )
+#endif
+
+         DO jspmset = 1, nspmsets
+             CALL obs_spm_opt( spmdatqc(jspmset),                &
+               &               kstp, jpi, jpj, nit000, spm(:,:), &
+               &               tmask(:,:,1), n2dint )
+         END DO         
+      ENDIF
+
+      IF ( ln_fco2 ) THEN
+         maskfco2(:,:) = tmask(:,:,1)         ! create a special mask to exclude certain things
+#if defined key_hadocc
+         fco2(:,:) = HADOCC_FCO2(:,:)    ! fCO2 from HadOCC
+         IF ( ( MINVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ).AND.( MAXVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ) ) THEN
+            fco2(:,:) = obfillflt
+            maskfco2(:,:) = 0
+            CALL ctl_warn( ' HadOCC fCO2 values masked out for observation operator', &
+               &           ' on timestep ' // TRIM(STR(kstp)),                              &
+               &           ' as HADOCC_FCO2(:,:) == HADOCC_FILL_FLT' )
+         ENDIF
+#elif defined key_medusa && defined key_foam_medusa
+         fco2(:,:) = MEDUSA_FCO2(:,:)    ! fCO2 from MEDUSA
+         IF ( ( MINVAL( MEDUSA_FCO2 ) == MEDUSA_FILL_FLT ).AND.( MAXVAL( MEDUSA_FCO2 ) == MEDUSA_FILL_FLT ) ) THEN
+            fco2(:,:) = obfillflt
+            maskfco2(:,:) = 0
+            CALL ctl_warn( ' MEDUSA fCO2 values masked out for observation operator', &
+               &           ' on timestep ' // TRIM(STR(kstp)),                              &
+               &           ' as MEDUSA_FCO2(:,:) == MEDUSA_FILL_FLT' )
+         ENDIF
+#elif defined key_fabm
+         ! First, get pCO2 from FABM
+         pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+         pco2(:,:) = pco2_3d(:,:,1)
+         ! Now, convert pCO2 to fCO2, based on SST in K. This follows the standard methodology of:
+         ! Pierrot et al. (2009), Recommendations for autonomous underway pCO2 measuring systems
+         ! and data reduction routines, Deep-Sea Research II, 56: 512-522.
+         ! and
+         ! Weiss (1974), Carbon dioxide in water and seawater: the solubility of a non-ideal gas,
+         ! Marine Chemistry, 2: 203-215.
+         ! In the implementation below, atmospheric pressure has been assumed to be 1 atm and so
+         ! not explicitly included - atmospheric pressure is not necessarily available so this is
+         ! the best assumption.
+         ! Further, the (1-xCO2)^2 term has been neglected. This is common practice
+         ! (see e.g. Zeebe and Wolf-Gladrow (2001), CO2 in Seawater: Equilibrium, Kinetics, Isotopes)
+         ! because xCO2 in atm is ~0, and so this term will only affect the result to the 3rd decimal
+         ! place for typical values, and xCO2 would need to be approximated from pCO2 anyway.
+         fco2(:,:) = pco2(:,:) * EXP((-1636.75                                                                               + &
+            &                         12.0408      * (tsn(:,:,1,jp_tem)+rt0)                                                 - &
+            &                         0.0327957    * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)                         + &
+            &                         0.0000316528 * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0) + &
+            &                         2.0 * (57.7 - 0.118 * (tsn(:,:,1,jp_tem)+rt0)))                                        / &
+            &                        (82.0578 * (tsn(:,:,1,jp_tem)+rt0)))
+#else
+         CALL ctl_stop( ' Trying to run fco2 observation operator', &
+            &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+         DO jfco2set = 1, nfco2sets
+             CALL obs_fco2_opt( fco2datqc(jfco2set),                      &
+               &                kstp, jpi, jpj, nit000, fco2(:,:), &
+               &                maskfco2(:,:), n2dint )
+         END DO
+      ENDIF
+
+      IF ( ln_pco2 ) THEN
+         maskpco2(:,:) = tmask(:,:,1)         ! create a special mask to exclude certain things
+#if defined key_hadocc
+         pco2(:,:) = HADOCC_PCO2(:,:)    ! pCO2 from HadOCC
+         IF ( ( MINVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ).AND.( MAXVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ) ) THEN
+            pco2(:,:) = obfillflt
+            maskpco2(:,:) = 0
+            CALL ctl_warn( ' HadOCC pCO2 values masked out for observation operator', &
+               &           ' on timestep ' // TRIM(STR(kstp)),                              &
+               &           ' as HADOCC_PCO2(:,:) == HADOCC_FILL_FLT' )
+         ENDIF
+#elif defined key_medusa && defined key_foam_medusa
+         pco2(:,:) = MEDUSA_PCO2(:,:)    ! pCO2 from MEDUSA
+         IF ( ( MINVAL( MEDUSA_PCO2 ) == MEDUSA_FILL_FLT ).AND.( MAXVAL( MEDUSA_PCO2 ) == MEDUSA_FILL_FLT ) ) THEN
+            pco2(:,:) = obfillflt
+            maskpco2(:,:) = 0
+            CALL ctl_warn( ' MEDUSA pCO2 values masked out for observation operator', &
+               &           ' on timestep ' // TRIM(STR(kstp)),                              &
+               &           ' as MEDUSA_PCO2(:,:) == MEDUSA_FILL_FLT' )
+         ENDIF
+#elif defined key_fabm
+         pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+         pco2(:,:) = pco2_3d(:,:,1)
+#else
+         CALL ctl_stop( ' Trying to run pCO2 observation operator', &
+            &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+         DO jpco2set = 1, npco2sets
+             CALL obs_pco2_opt( pco2datqc(jpco2set),                      &
+               &                kstp, jpi, jpj, nit000, pco2(:,:), &
+               &                maskpco2(:,:), n2dint )
+         END DO
+      ENDIF
+
 #if ! defined key_lim2 && ! defined key_lim3
       CALL wrk_dealloc(jpi,jpj,frld) 
@@ -1212,8 +1779,12 @@
       INTEGER :: jsstset                  ! SST data set loop variable
       INTEGER :: jseaiceset               ! Sea Ice data set loop variable
+      INTEGER :: jlogchlset               ! logchl data set loop variable
+      INTEGER :: jspmset                  ! spm data set loop variable
+      INTEGER :: jfco2set                 ! fco2 data set loop variable
+      INTEGER :: jpco2set                 ! pco2 data set loop variable
       INTEGER :: jset
       INTEGER :: jfbini
       CHARACTER(LEN=20) :: datestr=" ",timestr=" "
-      CHARACTER(LEN=10) :: cdtmp
+      CHARACTER(LEN=20) :: cdtmp
       !-----------------------------------------------------------------------
       ! Depending on switches call various observation output routines
